### Specifications

MimeKit implements the following IETF specifications defining Internet Mail and MIME:

* [0822](http://tools.ietf.org/html/rfc0822): Standard for the Format of Arpa Internet Text Messages
* [1341](http://tools.ietf.org/html/rfc1341): MIME (Multipurpose Internet Mail Extensions): Mechanisms for Specifying and Describing the Format of Internet Message Bodies
* [1342](http://tools.ietf.org/html/rfc1342): Representation of Non-ASCII Text in Internet Message Headers
* [1521](http://tools.ietf.org/html/rfc1521): MIME (Multipurpose Internet Mail Extensions) Part One: Mechanisms for Specifying and Describing the Format of Internet Message Bodies (Obsoletes rfc1341)
* [1522](http://tools.ietf.org/html/rfc1522): MIME (Multipurpose Internet Mail Extensions) Part Two: Message Header Extensions for Non-ASCII Text (Obsoletes rfc1342)
* [1544](http://tools.ietf.org/html/rfc1544): The Content-MD5 Header Field
* [1847](http://tools.ietf.org/html/rfc1847): Security Multiparts for MIME: Multipart/Signed and Multipart/Encrypted
* [1864](http://tools.ietf.org/html/rfc1864): The Content-MD5 Header Field (Obsoletes rfc1544)
* [1872](http://tools.ietf.org/html/rfc1872): The MIME Multipart/Related Content-type
* [1892](http://tools.ietf.org/html/rfc1892): The Multipart/Report Content Type for the Reporting of  Mail System Administrative Messages
* [2015](http://tools.ietf.org/html/rfc2015): MIME Security with Pretty Good Privacy (PGP)
* [2045](http://tools.ietf.org/html/rfc2045): Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies
* [2046](http://tools.ietf.org/html/rfc2046): Multipurpose Internet Mail Extensions (MIME) Part Two: Media Types
* [2047](http://tools.ietf.org/html/rfc2047): Multipurpose Internet Mail Extensions (MIME) Part Three: Message Header Extensions for Non-ASCII Text
* [2048](http://tools.ietf.org/html/rfc2048): Multipurpose Internet Mail Extensions (MIME) Part Four: Registration Procedures
* [2049](http://tools.ietf.org/html/rfc2049): Multipurpose Internet Mail Extensions (MIME) Part Five: Conformance Criteria and Examples
* [2110](http://tools.ietf.org/html/rfc2110): MIME E-mail Encapsulation of Aggregate Documents, such as HTML (MHTML)
* [2111](http://tools.ietf.org/html/rfc2111): Content-ID and Message-ID Uniform Resource Locators
* [2112](http://tools.ietf.org/html/rfc2112): The MIME Multipart/Related Content-type (Obsoletes rfc1872)
* [2183](http://tools.ietf.org/html/rfc2183): Communicating Presentation Information in Internet Messages: The Content-Disposition Header Field
* [2184](http://tools.ietf.org/html/rfc2184): MIME Parameter Value and Encoded Word Extensions: Character Sets, Languages, and Continuations
* [2231](http://tools.ietf.org/html/rfc2231): MIME Parameter Value and Encoded Word Extensions: Character Sets, Languages, and Continuations (Obsoletes rfc2184)
* [2298](http://tools.ietf.org/html/rfc2298): An Extensible Message Format for Message Disposition Notifications
* [2311](http://tools.ietf.org/html/rfc2311): S/MIME Version 2 Message Specification
* [2312](http://tools.ietf.org/html/rfc2312): S/MIME Version 2 Certificate Handling
* [2315](http://tools.ietf.org/html/rfc2315): PKCS #7: Cryptographic Message Syntax
* [2387](http://tools.ietf.org/html/rfc2387): The MIME Multipart/Related Content-type (Obsoletes rfc2112)
* [2424](http://tools.ietf.org/html/rfc2424): Content Duration MIME Header Definition
* [2557](http://tools.ietf.org/html/rfc2557): MIME Encapsulation of Aggregate Documents, such as HTML (MHTML) (Obsoletes rfc2110)
* [2630](http://tools.ietf.org/html/rfc2630): Cryptographic Message Syntax
* [2632](http://tools.ietf.org/html/rfc2632): S/MIME Version 3 Certificate Handling
* [2633](http://tools.ietf.org/html/rfc2633): S/MIME Version 3 Message Specification
* [2634](http://tools.ietf.org/html/rfc2634): Enhanced Security Services for S/MIME
* [2822](http://tools.ietf.org/html/rfc2822): Internet Message Format (Obsoletes rfc0822)
* [3156](http://tools.ietf.org/html/rfc3156): MIME Security with OpenPGP (Updates rfc2015)
* [3462](http://tools.ietf.org/html/rfc3462): The Multipart/Report Media Type for the Reporting of Mail System Administrative Messages (Obsoletes rfc1892)
* [3464](http://tools.ietf.org/html/rfc3464): An Extensible Message Format for Delivery Status Notifications
* [3798](http://tools.ietf.org/html/rfc3798): Message Disposition Notification (Obsoletes rfc2298)
* [3850](http://tools.ietf.org/html/rfc3850): S/MIME Version 3.1 Certificate Handling (Obsoletes rfc2632)
* [3851](http://tools.ietf.org/html/rfc3851): S/MIME Version 3.1 Message Specification (Obsoletes rfc2633)
* [4262](http://tools.ietf.org/html/rfc4262): X.509 Certificate Extension for S/MIME Capabilities
* [4871](http://tools.ietf.org/html/rfc4871): DomainKeys Identified Mail (DKIM) Signatures
* [5322](http://tools.ietf.org/html/rfc5322): Internet Message Format (Obsoletes rfc2822)
* [5451](http://tools.ietf.org/html/rfc5451): Message Header Field for Indicating Message Authentication Status
* [5672](http://tools.ietf.org/html/rfc5672): RFC 4871 DomainKeys Identified Mail (DKIM) Signatures -- Update
* [5750](http://tools.ietf.org/html/rfc5750): S/MIME Version 3.2 Certificate Handling (Obsoletes rfc3850)
* [5751](http://tools.ietf.org/html/rfc5751): S/MIME Version 3.2 Message Specification (Obsoletes rfc3851)
* [6376](http://tools.ietf.org/html/rfc6376): DomainKeys Identified Mail (DKIM) Signatures (Obsoletes rfc4871)
* [6522](http://tools.ietf.org/html/rfc6522): The Multipart/Report Media Type for the Reporting of Mail System Administrative Messages (Obsoletes rfc3462)
* [6532](http://tools.ietf.org/html/rfc6532): Internationalized Email Headers
* [6533](http://tools.ietf.org/html/rfc6533): Internationalized Delivery Status and Disposition Notifications
* [7001](http://tools.ietf.org/html/rfc7001): Message Header Field for Indicating Message Authentication Status (Obsoletes rfc5451)
* [7601](http://tools.ietf.org/html/rfc7601): Message Header Field for Indicating Message Authentication Status (Obsoletes rfc7001)
* [8301](http://tools.ietf.org/html/rfc8301): Cryptographic Algorithm and Key Usage Update to DomainKeys Identified Mail (DKIM)
* [8463](http://tools.ietf.org/html/rfc8463): A New Cryptographic Signature Method for DomainKeys Identified Mail (DKIM)

#### Other RFCs of interest:

* [1523](http://tools.ietf.org/html/rfc1523): The text/enriched MIME Content-type
* [1927](http://tools.ietf.org/html/rfc1927): Suggested Additional MIME Types for Associating Documents
* [2369](http://tools.ietf.org/html/rfc2369): The Use of URLs as Meta-Syntax for Core Mail List Commands and their Transport through Message Header Fields
* [2388](http://tools.ietf.org/html/rfc2388): Returning Values from Forms: multipart/form-data
* [6577](http://tools.ietf.org/html/rfc6577): Authentication-Results Registration Update for Sender Policy Framework (SPF) Results
* [7103](http://tools.ietf.org/html/rfc7103): Advice for Safe Handling of Malformed Messages
* [7410](http://tools.ietf.org/html/rfc7410): A Property Types Registry for the Authentication-Results Header Field
* [8550](http://tools.ietf.org/html/rfc8550): S/MIME Version 4.0 Certificate Handling (Obsoletes rfc5750)
* [8551](http://tools.ietf.org/html/rfc8551): S/MIME Version 4.0 Message Specification (Obsoletes rfc5751)
